#include <iostream>
#include <vector>
const size_t SCREEN_WIDTH = 80;
const size_t MAX_STAR = SCREEN_WIDTH - 3 - 1;
using namespace std;

int main()
{
    size_t number_count;
    cerr << "Enter number count: ";
    cin >> number_count;
    vector<double> numbers(number_count);

    for (size_t i = 0; i < number_count; i++)
    {
        cin >> numbers[i];
    }

    size_t bin_count;
    cerr << "Enter bin count: ";
    cin >> bin_count;
    vector<size_t> bins(bin_count);

    double min = numbers[0];
    double max = numbers[0];

    for (double x : numbers)
    {
        if (x < min)
        {
            min = x;
        }
        else if (x > max)
        {
            max = x;
        }
    }

    double bin_size = (max - min) / bin_count;

    for (size_t i = 0; i < number_count; i++)
    {
        bool found = false;
        for (size_t j = 0; (j < bin_count - 1) && !found; j++)
        {
            auto lo = min + j * bin_size;
            auto hi = min + (j + 1) * bin_size;
            if ((lo <= numbers[i]) && (numbers[i] < hi))
            {
                bins[j]++;
                found = true;
            }
        }
        if (!found)
        {
            bins[bin_count - 1]++;
        }
    }

    double b;
    for (size_t i = 0; i < bin_count; i++)
    {
        if (bins[i] > bins[i+1])
        {
            b = bins[i];
            bins[i] = bins[i + 1];
            bins[i + 1] = b;
        }
    }

    size_t max_star_search = bins[-1]; // поиск наибольшего кол-ва из корзины

    if (max_star_search > MAX_STAR)
    {
        for (size_t x : bins)
        {
            size_t height = MAX_STAR * (static_cast<double>(x) / max_star_search);
            if (x < 100)
            {
                cout << " ";
                if (x < 10)
                {
                    cout << " ";
                }
            }
            cout << x << "|";
            for (size_t i = 0; i < height; i++)
            {
                cout << "*";
            }
            cout << endl;
        }
    }
    else
    {
        for (size_t x : bins)
        {
            if (x < 100)
            {
                cout << " ";
                if (x < 10)
                {
                    cout << " ";
                }
            }
            cout << x << "|";
            for (size_t i = 0; i < x; i++)
            {
                cout << "*";
            }
            cout << endl;
        }
    }

    return 0;
}
